import "Turbine.UI"; 
import "Turbine.UI.Lotro"; 
import "Turbine.Gameplay"
import "Turbine.Debug"
import "Turbine.UI.Extensions"
import "Iinferno.debuffhelper.timer"
--import "Iinferno.debuffhelper.skillhelper.SkillInfo"

debuffBar = class(Turbine.UI.Extensions.SimpleWindow );
function debuffBar:Constructor()
	Turbine.UI.Extensions.SimpleWindow.Constructor( self );
	
	--self.quickslotSize = 36;
	--self.quickslots = { };
	
	self.width = 250;
	self.height = 46;
	self:SetSize( self.width , self.height );
	self:SetVisible(true);
	self:SetPosition((Turbine.UI.Display.GetWidth() / 2) - 150 , Turbine.UI.Display.GetHeight() / 2 + 150)
	--[[
		self.quickslot1 = Turbine.UI.Lotro.Quickslot();		
		self.quickslot1:SetParent( self );
		self.quickslot1:SetZOrder(100);
		self.quickslot1:SetSize(36, 36);
		Turbine.Shell.WriteLine("working up to line 21");
	--self.quickslot1:SetVisible(true);]]
	
	debuffs = {firelore = "0x70003EBE", windlore =  "0x70003EBF", frostlore = "0x70024BE7", ancientcraft = "0x7000B627", allends = "0x7000F801" }
	
	--debuff slot: SoP:SaE
	self.quickslot1 = Turbine.UI.Lotro.Quickslot();		
	self.quickslot1:SetParent( self );
	self.quickslot1:SetZOrder(100);
	self.quickslot1:SetSize(36, 36);
	self.quickslot1:SetPosition(0 , self.height/36);
	self.quickslot1:SetShortcut( Turbine.UI.Lotro.Shortcut ( 6.0,  debuffs.allends ));
	
	
	--debuff slot: Ancient Craft
	self.quickslot2 = Turbine.UI.Lotro.Quickslot();		
	self.quickslot2:SetParent( self );
	self.quickslot2:SetZOrder(100);
	self.quickslot2:SetSize(36, 36);
	self.quickslot2:SetPosition(36 , self.height/36)
	self.quickslot2:SetShortcut( Turbine.UI.Lotro.Shortcut ( 6.0,  debuffs.ancientcraft ));
	
	--debuff slot: Wind Lore
	self.quickslot3 = Turbine.UI.Lotro.Quickslot();		
	self.quickslot3:SetParent( self );
	self.quickslot3:SetZOrder(100);
	self.quickslot3:SetSize(36, 36);
	self.quickslot3:SetPosition(72 , self.height/36)
	self.quickslot3:SetShortcut( Turbine.UI.Lotro.Shortcut ( 6.0,  debuffs.windlore ));
	
	--debuff slot: Fire Lore
	self.quickslot4 = Turbine.UI.Lotro.Quickslot();		
	self.quickslot4:SetParent( self );
	self.quickslot4:SetZOrder(100);
	self.quickslot4:SetSize(36, 36);
	self.quickslot4:SetPosition(108 , self.height/36)
	self.quickslot4:SetShortcut( Turbine.UI.Lotro.Shortcut ( 6.0,  debuffs.firelore ));
	
	--debuff slot: Frost Lore
	self.quickslot5 = Turbine.UI.Lotro.Quickslot();		
	self.quickslot5:SetParent( self );
	self.quickslot5:SetZOrder(100);
	self.quickslot5:SetSize(36, 36);
	self.quickslot5:SetPosition(144 , self.height/36)
	self.quickslot5:SetShortcut( Turbine.UI.Lotro.Shortcut ( 6.0,  debuffs.frostlore ));
	--Iinferno.debuffhelper.skillhelper.SkillInfo.SkillInfoWindow:getCooldown("Fire-lore")
	--[[self.quickslot5.MouseClick=function()
		self.quickslot5:SetVisible(false);
	end]]
	
	self.MouseDown = function(sender, args )
		if (args.Button == Turbine.UI.MouseButton.Left) then
			isMoving = true;
			x = args.X;
			y = args.Y;
		end
	end
	self.MouseUp = function(sender, args )
		if (args.Button == Turbine.UI.MouseButton.Left) then
			isMoving = false;
			local one,two = self:GetPosition();
		end
	end
	
	self.MouseMove = function(sender, args )
		if (isMoving) then
			local oldX,oldY = self:GetPosition();
			self:SetPosition(oldX + args.X - x,oldY + args.Y - y);	
		end
	end
	
end

function AddCallback(object, event, callback)
	if (object[event] == nil) then
		object[event] = callback;
		else
		if (type(object[event]) == "table") then
			table.insert(object[event], callback);
			else
			object[event] = {object[event], callback};
		end
	end
end
function Split(str)
	--local numchar = ""
	local stringArray = { }
	--local temp = "%a"
	local s
	for i = 1 , string.len(str) do 
		s = findpattern(str,".", i) --find the first letter of s
		stringArray[i] = s --store that letter in an array to be returned (split string)
		--numchar = numchar .. "." --add another wildcard to the beginning of temp
		--temp = numchar .. temp --allows s to find the next letter of the string instead
		--of repeating
	end
	return stringArray
    
end
function arrayLen(array)
	i = 1 --until the array says 'nill' incrament i, then return i (length)
	while array[i] ~= nil do
		i = i + 1
	end
	return i
end
function strjoin(array)
	local len = arrayLen(array)
	local str = tostring(array[1])
	for i = 2, len - 1 do
		str = str .. tostring(array[i]) -- error: attempt to contactenate field (?) a nil value
	end
	return str
end

function findPhrase(msg,phrase)
	--firelore = {"F", "i", "r", "e", "-", "l", "o", "r", "e"}
	--for i = 0, string.len(phrase) do
	--	if phrase[i] = 
	local splitMsg = Split(msg)	-- split the strings into an array:
	local splitPhrase = Split(phrase)
	result = { } -- array to store the results after the message is found
	local firstOccur = string.find(msg, findpattern(phrase,".")) --finds the first occurance of a letter in phrase
	if firstOccur ~= nil then
		for i = 1, string.len(phrase) do 
			result[i] = splitMsg[firstOccur + (i - 1)]	--stores the results of letters after the occurance of the first letter in the phrase, up to the last letter of the length of the phrase
		end
		
		resultStr = ""
		--for i=1, arrayLen(result) do
		
		--[[end
			for i=1, arrayLen(splitPhrase) do
			Turbine.Shell.WriteLine(splitPhrase[i])
			end
			for i=1, arrayLen(splitMsg) do
			Turbine.Shell.WriteLine(splitMsg[i])
			end
			--resultStr = strjoin(result)
		]]
		resultStr = strjoin(result)
		if resultStr == phrase then
			
			return true --checks if the result is the same as  phrase
		end
	end
end
function findpattern(text, pattern, start) 
	if start == nil then
		return string.sub(text, string.find(text,pattern))
		else
		return string.sub(text, string.find(text,pattern,start))
	end
end
--[[
	function updateTime(quickslot)
	local gameTime = Turbine.Engine.GetGameTime()
	local visible = false
	if visible == false then
	quickslot:SetVisible(false)
	if gameTime >= curTime + 60 then
	quickslot:SetVisible(true)
	visible = true
	else
	gameTime = Turbine.Engine.GetGameTime()
	updateTime(quickslot)
	end
	quickslot:SetVisible(true)
	end
	end
	
	function timer(duration,startTime)
	local completed = false
	local timestamp = Turbine.Engine.GetGameTime()
	if timestamp >= startTime + duration then
	completed = true
	return completed
	else
	timer(duration,startTime)
	end
	end
]]

AddCallback(Turbine.Chat,"Received",function(sender, args)
	msg = string.gsub(args.Message,"<rgb=#......>(.*)</rgb>","")
	
	--Turbine.Shell.WriteLine("startTime:" .. tostring(math.floor(startTime)))
	--Turbine.Shell.WriteLine("currentTime:" .. tostring(math.floor(bar1.currentTime)))
	--Turbine.Shell.WriteLine(delta)
	if findPhrase(msg,"Sign of Power: See All Ends") == true then
		bar1.quickslot1:SetVisible(false)
		timer1:SetTime(60, true)
		AddCallback(timer1,"TimeReached",function() 
			bar1.quickslot1:SetVisible(true)
		end)
		--while delta < 60 do
		--currentTime = Turbine.Engine.GetGameTime()
		--delta = math.floor(currentTime) - math.floor(startTime)
		--end
		--Turbine.Shell.WriteLine("yay")
	end
	if findPhrase(msg,"Ancient Craft") == true then
		bar1.quickslot2:SetVisible(false)
		timer2:SetTime(60, true)
		AddCallback(timer2,"TimeReached",function() 
			bar1.quickslot2:SetVisible(true)
		end)
		--while delta < 60 do
		--currentTime = Turbine.Engine.GetGameTime()
		--delta = math.floor(currentTime) - math.floor(startTime)
		--end
		--Turbine.Shell.WriteLine("yay")
	end
	if findPhrase(msg,"Wind-lore") == true then
		bar1.quickslot3:SetVisible(false)
		timer3:SetTime(30, true)
		AddCallback(timer3,"TimeReached",function() 
			bar1.quickslot3:SetVisible(true)
		end)
		--while delta < 60 do
		--currentTime = Turbine.Engine.GetGameTime()
		--delta = math.floor(currentTime) - math.floor(startTime)
		--end
		--Turbine.Shell.WriteLine("yay")
	end
	if findPhrase(msg,"Fire-lore") == true then
		bar1.quickslot4:SetVisible(false)
		timer4:SetTime(60, true)
		AddCallback(timer4,"TimeReached",function() 
			bar1.quickslot4:SetVisible(true)
		end)
		--while delta < 60 do
		--currentTime = Turbine.Engine.GetGameTime()
		--delta = math.floor(currentTime) - math.floor(startTime)
		--end
		--Turbine.Shell.WriteLine("yay")
	end
	if findPhrase(msg,"Frost-lore") == true then
		bar1.quickslot5:SetVisible(false)
		timer5:SetTime(60, true)
		AddCallback(timer5,"TimeReached",function() 
			bar1.quickslot5:SetVisible(true)
		end)
		--while delta < 60 do
		--currentTime = Turbine.Engine.GetGameTime()
		--delta = math.floor(currentTime) - math.floor(startTime)
		--end
		--Turbine.Shell.WriteLine("yay")
	end
end )
timer1=Timer();
timer2=Timer();
timer3=Timer();
timer4=Timer();
timer5=Timer();
bar1 = debuffBar();